OpenTTD Source: RoadStop Struct Reference

OpenTTD Source 15.0-beta1

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Static Public Attributes | Private Member Functions | Private Attributes
RoadStop Struct Reference

A Stop for a Road Vehicle. More...

`#include <roadstop_base.h>`

Inheritance diagram for RoadStop:

## Data Structures
struct | Entry
| Container for each entry point of a drive through road stop. More...

## Public Types
enum | RoadStopStatusFlags { RSSFB_BAY0_FREE = 0 , RSSFB_BAY1_FREE = 1 , RSSFB_BASE_ENTRY = 6 , RSSFB_ENTRY_BUSY = 7 }
Public Types inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_roadstop_pool >
typedef struct Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero > | Pool
| Type of the pool this item is going to be part of.

## Public Member Functions
| RoadStop (TileIndex tile=INVALID_TILE)
| Initializes a RoadStop.
| ~RoadStop ()
| De-Initializes RoadStops.
bool | HasFreeBay () const
| Checks whether there is a free bay in this road stop.
bool | IsFreeBay (uint nr) const
| Checks whether the given bay is free in this road stop.
bool | IsEntranceBusy () const
| Checks whether the entrance of the road stop is occupied by a vehicle.
void | SetEntranceBusy (bool busy)
| Makes an entrance occupied or free.
const Entry * | GetEntry (DiagDirection dir) const
| Get the drive through road stop entry struct for the given direction.
Entry * | GetEntry (DiagDirection dir)
| Get the drive through road stop entry struct for the given direction.
void | MakeDriveThrough ()
| Join this road stop to another 'base' road stop if possible; fill all necessary data to become an actual drive through road stop.
void | ClearDriveThrough ()
| Prepare for removal of this stop; update other neighbouring stops if needed.
void | Leave (RoadVehicle *rv)
| Leave the road stop.
bool | Enter (RoadVehicle *rv)
| Enter the road stop.
RoadStop * | GetNextRoadStop (const struct RoadVehicle *v) const
| Get the next road stop accessible by this vehicle.
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_roadstop_pool >
void * | operator new (size_t size)
| Allocates space for new Titem.
void * | operator new (size_t size, size_t index)
| Allocates space for new Titem with given index.
void * | operator new (size_t, void *ptr)
| Allocates space for new Titem at given memory address.
void | operator delete (void *p)
| Marks Titem as free.

## Static Public Member Functions
static RoadStop * | GetByTile (TileIndex tile, RoadStopType type)
| Find a roadstop at given tile.
static bool | IsDriveThroughRoadStopContinuation (TileIndex rs, TileIndex next)
| Checks whether the 'next' tile is still part of the road same drive through stop 'rs' in the same direction for the same vehicle.
Static Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_roadstop_pool >
static bool | CanAllocateItem (size_t n=1)
| Helper functions so we can use PoolItem::Function() instead of _poolitem_pool.Function()
static bool | CleaningPool ()
| Returns current state of pool cleaning - yes or no.
static bool | IsValidID (size_t index)
| Tests whether given index can be used to get valid (non-nullptr) Titem.
static Titem * | Get (size_t index)
| Returns Titem with given index.
static Titem * | GetIfValid (size_t index)
| Returns Titem with given index.
static size_t | GetPoolSize ()
| Returns first unused index.
static size_t | GetNumItems ()
| Returns number of valid items in the pool.
static void | PostDestructor (size_t index)
| Dummy function called after destructor of each member.
static Pool::IterateWrapper< Titem > | Iterate (size_t from=0)
| Returns an iterable ensemble of all valid Titem.

## Data Fields
uint8_t | status
| Current status of the Stop,.
TileIndex | xy
| Position on the map.
RoadStop * | next
| Next stop of the given type at this station.
Data Fields inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_roadstop_pool >
Tindex | index
| Index of this pool item.

## Static Public Attributes
static constexpr uint8_t | BAY_COUNT = 2
| Max. number of bays.

## Private Member Functions
uint | AllocateBay ()
| Allocates a bay.
void | AllocateDriveThroughBay (uint nr)
| Allocates a bay in a drive-through road stop.
void | FreeBay (uint nr)
| Frees the given bay.

## Private Attributes
Entry * | east
| The vehicles that entered from the east.
Entry * | west
| The vehicles that entered from the west.

## Detailed Description

A Stop for a Road Vehicle.

Definition at line 22 of file roadstop_base.h.

## Member Enumeration Documentation

## ◆ RoadStopStatusFlags

enum RoadStop::RoadStopStatusFlags

Enumerator
RSSFB_BAY0_FREE | Non-zero when bay 0 is free.
RSSFB_BAY1_FREE | Non-zero when bay 1 is free.
RSSFB_BASE_ENTRY | Non-zero when the entries on this road stop are the primary, i.e. the ones to delete.
RSSFB_ENTRY_BUSY | Non-zero when roadstop entry is busy.

Definition at line 23 of file roadstop_base.h.

## Constructor & Destructor Documentation

## ◆ RoadStop()

RoadStop::RoadStop | ( | TileIndex | tile = `INVALID_TILE` | ) |
| inline

Initializes a RoadStop.

Definition at line 73 of file roadstop_base.h.

## ◆ ~RoadStop()

RoadStop::~RoadStop | ( |  | ) |

De-Initializes RoadStops.

Definition at line 26 of file roadstop.cpp.

References HasBit().

## Member Function Documentation

## ◆ AllocateBay()

uint RoadStop::AllocateBay | ( |  | ) |
| inlineprivate

Allocates a bay.

Returns
  the allocated bay number

Precondition
  this->HasFreeBay()

Definition at line 159 of file roadstop_base.h.

References ClrBit(), HasBit(), and HasFreeBay().

Referenced by Enter().

## ◆ AllocateDriveThroughBay()

void RoadStop::AllocateDriveThroughBay | ( | uint | nr | ) |
| inlineprivate

Allocates a bay in a drive-through road stop.

Parameters

  nr | the number of the bay to allocate

Definition at line 175 of file roadstop_base.h.

References BAY_COUNT, and ClrBit().

## ◆ ClearDriveThrough()

void RoadStop::ClearDriveThrough | ( |  | ) |

Prepare for removal of this stop; update other neighbouring stops if needed.

Also update the length etc.

Definition at line 129 of file roadstop.cpp.

References ClrBit(), east, GetByTile(), GetDriveThroughStopAxis(), GetRoadStopType(), HasBit(), IsDriveThroughRoadStopContinuation(), RoadStop::Entry::length, RoadStop::Entry::Rebuild(), RSSFB_BASE_ENTRY, SetBit(), status, TILE_SIZE, TileOffsByAxis(), west, and xy.

Referenced by RemoveRoadStop().

## ◆ Enter()

bool RoadStop::Enter | ( | RoadVehicle * | rv | ) |

Enter the road stop.

Parameters

  rv | the vehicle that enters the stop

Returns
  whether the road stop could actually be entered

Definition at line 231 of file roadstop.cpp.

References AllocateBay(), Vehicle::direction, DirToDiagDir(), RoadStop::Entry::Enter(), GetEntry(), Vehicle::HasArticulatedPart(), HasFreeBay(), IsBayRoadStopTile(), IsEntranceBusy(), RVS_IN_DT_ROAD_STOP, RVS_IN_ROAD_STOP, RVS_USING_SECOND_BAY, SB(), SetBit(), SetEntranceBusy(), RoadVehicle::state, and xy.

## ◆ FreeBay()

void RoadStop::FreeBay | ( | uint | nr | ) |
| inlineprivate

Frees the given bay.

Parameters

  nr | the number of the bay to free

Definition at line 185 of file roadstop_base.h.

References BAY_COUNT, and SetBit().

Referenced by Leave().

## ◆ GetByTile()

RoadStop * RoadStop::GetByTile | ( | TileIndex | tile,
|  | RoadStopType | type
| ) |  |
| static

Find a roadstop at given tile.

Parameters

  tile | tile with roadstop
  type | roadstop type

Returns
  pointer to RoadStop

Precondition
  there has to be roadstop of given type there!

Definition at line 264 of file roadstop.cpp.

References BaseStation::GetByTile().

Referenced by ClearDriveThrough(), RoadVehicle::Crash(), DeleteLastRoadVeh(), MakeDriveThrough(), CYapfCostRoadT< Types >::OneTileCost(), Vehicle::PreDestructor(), RemoveRoadStop(), and RoadFindPathToDest().

## ◆ GetEntry() [1/2]

Entry * RoadStop::GetEntry | ( | DiagDirection | dir | ) |
| inline

Get the drive through road stop entry struct for the given direction.

Parameters

  dir | The direction to get the entry for.

Returns
  the entry

Definition at line 133 of file roadstop_base.h.

References east, HasBit(), and west.

## ◆ GetEntry() [2/2]

const Entry * RoadStop::GetEntry | ( | DiagDirection | dir | ) | const
| inline

Get the drive through road stop entry struct for the given direction.

Parameters

  dir | The direction to get the entry for.

Returns
  the entry

Definition at line 123 of file roadstop_base.h.

References east, HasBit(), and west.

Referenced by Enter(), Leave(), and CYapfCostRoadT< Types >::OneTileCost().

## ◆ GetNextRoadStop()

RoadStop * RoadStop::GetNextRoadStop | ( | const struct RoadVehicle * | v | ) | const

Get the next road stop accessible by this vehicle.

Parameters

  v | the vehicle to get the next road stop for.

Returns
  the next road stop accessible.

Definition at line 42 of file roadstop.cpp.

References RoadVehicle::compatible_roadtypes, Vehicle::HasArticulatedPart(), HasTileAnyRoadType(), IsBayRoadStopTile(), and next.

## ◆ HasFreeBay()

bool RoadStop::HasFreeBay | ( |  | ) | const
| inline

Checks whether there is a free bay in this road stop.

Returns
  is at least one bay free?

Definition at line 84 of file roadstop_base.h.

References BAY_COUNT, and GB().

Referenced by AllocateBay(), and Enter().

## ◆ IsDriveThroughRoadStopContinuation()

bool RoadStop::IsDriveThroughRoadStopContinuation | ( | TileIndex | rs,
|  | TileIndex | next
| ) |  |
| static

Checks whether the 'next' tile is still part of the road same drive through stop 'rs' in the same direction for the same vehicle.

Parameters

  rs | the road stop tile to check against
  next | the 'next' tile to check

Returns
  true if the 'next' tile is part of the road stop at 'next'.

Definition at line 303 of file roadstop.cpp.

References GetDriveThroughStopAxis(), GetStationIndex(), GetStationType(), IsDriveThroughStopTile(), IsTileType(), MP_STATION, and next.

Referenced by RoadStop::Entry::CheckIntegrity(), ClearDriveThrough(), MakeDriveThrough(), CYapfCostRoadT< Types >::OneTileCost(), and RoadStop::Entry::Rebuild().

## ◆ IsEntranceBusy()

bool RoadStop::IsEntranceBusy | ( |  | ) | const
| inline

Checks whether the entrance of the road stop is occupied by a vehicle.

Returns
  is entrance busy?

Definition at line 104 of file roadstop_base.h.

References HasBit(), and RSSFB_ENTRY_BUSY.

Referenced by Enter().

## ◆ IsFreeBay()

bool RoadStop::IsFreeBay | ( | uint | nr | ) | const
| inline

Checks whether the given bay is free in this road stop.

Parameters

  nr | bay to check

Returns
  is given bay free?

Definition at line 94 of file roadstop_base.h.

References BAY_COUNT, and HasBit().

Referenced by CYapfCostRoadT< Types >::OneTileCost().

## ◆ Leave()

void RoadStop::Leave | ( | RoadVehicle * | rv | ) |

Leave the road stop.

Parameters

  rv | the vehicle that leaves the stop

Definition at line 214 of file roadstop.cpp.

References Vehicle::direction, DirToDiagDir(), FreeBay(), GetEntry(), HasBit(), IsBayRoadStopTile(), RoadStop::Entry::Leave(), RVS_USING_SECOND_BAY, SetEntranceBusy(), RoadVehicle::state, and Vehicle::tile.

Referenced by RoadVehicle::Crash(), DeleteLastRoadVeh(), and Vehicle::PreDestructor().

## ◆ MakeDriveThrough()

void RoadStop::MakeDriveThrough | ( |  | ) |

Join this road stop to another 'base' road stop if possible; fill all necessary data to become an actual drive through road stop.

Also update the length etc.

Definition at line 62 of file roadstop.cpp.

References ClrBit(), east, GetByTile(), GetDriveThroughStopAxis(), GetRoadStopType(), IsDriveThroughRoadStopContinuation(), RoadStop::Entry::length, RoadStop::Entry::occupied, RSSFB_BASE_ENTRY, SetBit(), status, TILE_SIZE, TileOffsByAxis(), west, and xy.

Referenced by CmdBuildRoadStop().

## ◆ SetEntranceBusy()

void RoadStop::SetEntranceBusy | ( | bool | busy | ) |
| inline

Makes an entrance occupied or free.

Parameters

  busy | If true, marks busy; free otherwise.

Definition at line 113 of file roadstop_base.h.

References RSSFB_ENTRY_BUSY, and SB().

Referenced by Enter(), and Leave().

## Field Documentation

## ◆ BAY_COUNT

constexpr uint8_t RoadStop::BAY_COUNT = 2
| staticconstexpr

Max. number of bays.

Definition at line 30 of file roadstop_base.h.

Referenced by AllocateDriveThroughBay(), FreeBay(), HasFreeBay(), and IsFreeBay().

## ◆ east

Entry* RoadStop::east
| private

The vehicles that entered from the east.

Definition at line 151 of file roadstop_base.h.

Referenced by RoadStop::Entry::CheckIntegrity(), ClearDriveThrough(), GetEntry(), GetEntry(), GetEntryDirection(), MakeDriveThrough(), and RoadStop::Entry::Rebuild().

## ◆ next

RoadStop* RoadStop::next

Next stop of the given type at this station.

Definition at line 70 of file roadstop_base.h.

Referenced by FindRoadStopSpot(), GetNextRoadStop(), GetVehicleCannotUseStationReason(), IsDriveThroughRoadStopContinuation(), and RemoveRoadStop().

## ◆ status

uint8_t RoadStop::status

Current status of the Stop,.

See also
  RoadStopSatusFlag. Access using *Bay and *Busy functions.

Definition at line 68 of file roadstop_base.h.

Referenced by RoadStop::Entry::CheckIntegrity(), ClearDriveThrough(), MakeDriveThrough(), and RoadStop::Entry::Rebuild().

## ◆ west

Entry* RoadStop::west
| private

The vehicles that entered from the west.

Definition at line 152 of file roadstop_base.h.

Referenced by ClearDriveThrough(), GetEntry(), GetEntry(), and MakeDriveThrough().

## ◆ xy

TileIndex RoadStop::xy

Position on the map.

Definition at line 69 of file roadstop_base.h.

Referenced by RoadStop::Entry::CheckIntegrity(), ClearDriveThrough(), Enter(), GetVehicleCannotUseStationReason(), MakeDriveThrough(), and RoadStop::Entry::Rebuild().

The documentation for this struct was generated from the following files:

- src/roadstop_base.h
- src/roadstop.cpp